diff --git a/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java b/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
index 26d048dc504266fd0a472eac13771e76e6418ce2..36be1fff52f902ff9bfbb13ab2f0f9500d640651 100644
--- a/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
+++ b/pki/base/util/src/netscape/security/extensions/SubjectInfoAccessExtension.java
@@ -46,13 +46,8 @@ import netscape.security.x509.URIName;
  * @version $Revision$, $Date$
  */
 public class SubjectInfoAccessExtension extends Extension implements CertAttrSet {
-    /**
-     *
-     */
     private static final long serialVersionUID = 7237321566602583325L;
 
-    public static final String NAME = "SubjectInfoAccessExtension";
-
     public static final int OID_OCSP[] = { 1, 3, 6, 1, 5, 5, 7, 48, 1 };
     public static final ObjectIdentifier METHOD_OCSP = new 
         ObjectIdentifier(OID_OCSP);
@@ -64,7 +59,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
     public static final int OID[] = { 1, 3, 6, 1, 5, 5, 7, 1, 11 };
     public static final ObjectIdentifier ID = new ObjectIdentifier(OID);
 
-    private Vector mDesc = new Vector();
+    private Vector<AccessDescription> mDesc = new Vector<AccessDescription>();
 
     /**
      * Create the extension from the passed DER encoded value of the same.
@@ -120,17 +115,11 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
         // NOT USED
         return null;
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-        return NAME;
-    }
 
     /**
      * Adds Access Description.
@@ -143,7 +132,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
     }
 
     public AccessDescription getAccessDescription(int pos) {
-        return (AccessDescription) mDesc.elementAt(pos);
+        return mDesc.elementAt(pos);
     }
 
     /**
@@ -174,7 +163,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
 
         for (int i = 0; i < mDesc.size(); i++) {
             DerOutputStream tmp0 = new DerOutputStream();
-            AccessDescription ad = (AccessDescription) mDesc.elementAt(i);
+            AccessDescription ad = mDesc.elementAt(i);
 
             tmp0.putOID(ad.getMethod());
             ad.getLocation().encode(tmp0);
@@ -207,7 +196,7 @@ public class SubjectInfoAccessExtension extends Extension implements CertAttrSet
         String s = super.toString() + "AuthInfoAccess [\n";
 
         for (int i = 0; i < mDesc.size(); i++) {
-            AccessDescription ad = (AccessDescription) mDesc.elementAt(i);
+            AccessDescription ad = mDesc.elementAt(i);
 
             s += "(" + i + ")";
             s += " ";
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java b/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
index e3eee809987af83c578eb4ff05d7b814b4c63121..dd74ead908df8223de1a850111bee7f574be84e7 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS10Attribute.java
@@ -114,17 +114,18 @@ public class PKCS10Attribute implements DerEncoder, Serializable {
 			}
 		}
 		byte[] val = inAttrValue.toByteArray();
-        Class[] params = { Object.class };
+        Class<?>[] params = { Object.class };
         try {
-			Class extClass = OIDMap.getClass(attributeId);
+			@SuppressWarnings("unchecked")
+			Class<CertAttrSet> extClass = (Class<CertAttrSet>) OIDMap.getClass(attributeId);
 			if (extClass != null) {
-            	Constructor cons = extClass.getConstructor(params);
+            	Constructor<CertAttrSet> cons = (Constructor<CertAttrSet>) extClass.getConstructor(params);
 				Object value = Array.newInstance(byte.class,val.length);
 				for (int i = 0; i < val.length; i++) {
 					Array.setByte(value,i,val[i]);
 				}
 				Object[] passed = new Object[] {value};
-            	attributeValue = (CertAttrSet) cons.newInstance(passed);
+            	attributeValue =  cons.newInstance(passed);
 			} else {
 				// attribute classes are usable for PKCS10 attributes. 
 				// this is used where the attributes are not actual 
diff --git a/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java b/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
index 683514a7fcd51cb9363678686ad3439beca3b813..fc25e8d8fc13bf6ed23631146e2dddb8bc0c13c3 100644
--- a/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
+++ b/pki/base/util/src/netscape/security/pkcs/PKCS9Attribute.java
@@ -112,7 +112,7 @@ public class PKCS9Attribute implements DerEncoder {
      * attributes to their OIDs. This table contains all name forms 
      * that occur in PKCS9, in lower case.
      */
-    private static final Hashtable NAME_OID_TABLE = new Hashtable(28);
+    private static final Hashtable<String, ObjectIdentifier> NAME_OID_TABLE = new Hashtable<String, ObjectIdentifier>(28);
 
     static { // static initializer for PCKS9_NAMES
 	NAME_OID_TABLE.put("emailaddress", PKCS9_OIDS[1]);
@@ -136,7 +136,7 @@ public class PKCS9Attribute implements DerEncoder {
      * Hashtable mapping attribute OIDs defined in PKCS9 to the
      * corresponding attribute value type.
      */
-    private static final Hashtable OID_NAME_TABLE = new Hashtable(14);
+    private static final Hashtable<ObjectIdentifier, String> OID_NAME_TABLE = new Hashtable<ObjectIdentifier, String>(14);
     static { 
 	OID_NAME_TABLE.put(PKCS9_OIDS[1], EMAIL_ADDRESS_STR);
 	OID_NAME_TABLE.put(PKCS9_OIDS[2], UNSTRUCTURED_NAME_STR);
@@ -298,15 +298,13 @@ public class PKCS9Attribute implements DerEncoder {
      *
      * </TABLE>
      */
-    private static final Class[] VALUE_CLASSES = new Class[15];
+    private static final Class<?>[] VALUE_CLASSES = new Class[15];
 
     static {
 	try {
-	    Class str = Class.forName("[Ljava.lang.String;");
-
 	    VALUE_CLASSES[0] = null;  // not used
-	    VALUE_CLASSES[1] = str;   // EMailAddress
-	    VALUE_CLASSES[2] = str;   // UnstructuredName
+	    VALUE_CLASSES[1] = java.lang.String.class;   // EMailAddress
+	    VALUE_CLASSES[2] = java.lang.String.class;   // UnstructuredName
 	    VALUE_CLASSES[3] =        // ContentType
 		Class.forName("netscape.security.util.ObjectIdentifier");
 	    VALUE_CLASSES[4] = Class.forName("[B"); // MessageDigest (byte[])
@@ -315,7 +313,7 @@ public class PKCS9Attribute implements DerEncoder {
 		Class.forName("[Lnetscape.security.pkcs.SignerInfo;");
 	    VALUE_CLASSES[7] =        // ChallengePassword
 		Class.forName("java.lang.String");   
-	    VALUE_CLASSES[8] = str;   // UnstructuredAddress
+	    VALUE_CLASSES[8] = java.lang.String.class;   // UnstructuredAddress
 	    VALUE_CLASSES[9] = null;  // ExtendedCertificateAttributes
 
 	    VALUE_CLASSES[10] = null;   // IssuerAndSerialNumber
diff --git a/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java b/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
index 22d253297d47d44f03714a3386e7bc2d3ce7906d..8e21350bd56ceb962867efe905cd03c8d364aaf5 100644
--- a/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
+++ b/pki/base/util/src/netscape/security/provider/X509CertificateFactory.java
@@ -35,7 +35,7 @@ public class X509CertificateFactory  extends CertificateFactorySpi {
 		throws CertificateException {
 		return new X509CertImpl(inStream);
 	}
-    public Collection engineGenerateCertificates(InputStream inStream)
+    public Collection<Certificate> engineGenerateCertificates(InputStream inStream)
 		throws CertificateException {
 		return null;
 	}
@@ -53,7 +53,7 @@ public class X509CertificateFactory  extends CertificateFactorySpi {
 		return crl;
 	}
 
-	public Collection engineGenerateCRLs(InputStream inStream)
+	public Collection<CRL> engineGenerateCRLs(InputStream inStream)
 		throws CRLException {
 		return null;
 	}
diff --git a/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java b/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
index ba74a0d73a1c68183cff0624c886515d17d4b7fd..ade2142093f779186cd47772d3d5ec9a5f236b83 100644
--- a/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
+++ b/pki/base/util/src/netscape/security/util/CrlPrettyPrint.java
@@ -27,7 +27,7 @@ import java.util.TimeZone;
 
 import netscape.security.x509.CRLExtensions;
 import netscape.security.x509.Extension;
-import netscape.security.x509.RevokedCertImpl;
+import netscape.security.x509.RevokedCertificate;
 import netscape.security.x509.X509CRLImpl;
 
 
@@ -177,15 +177,14 @@ public class CrlPrettyPrint
                 }
                 sb.append("\n");
 
-                Set revokedCerts = mCRL.getRevokedCertificates();
+                Set<RevokedCertificate> revokedCerts = mCRL.getRevokedCertificates();
 
                 if (revokedCerts != null) {
-                    Iterator i = revokedCerts.iterator();
+                    Iterator<RevokedCertificate> i = revokedCerts.iterator();
                     long l = 1;
 
                     while ((i.hasNext()) && ((crlSize == 0) || (pageStart + pageSize > l))) {
-                        RevokedCertImpl revokedCert =
-                            (RevokedCertImpl) i.next();
+                        RevokedCertificate revokedCert = i.next();
 
                         if ((crlSize == 0) || ((pageStart <= l) && (pageStart + pageSize > l))) {
                             sb.append(pp.indent(16) + resource.getString(
diff --git a/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java b/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
index 2e57eac17c3dc0ac8588db5bf18570e31882689c..0c62012d54c575a559459c4ee7515056e7e81257 100644
--- a/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
+++ b/pki/base/util/src/netscape/security/util/ExtPrettyPrint.java
@@ -506,7 +506,7 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(
                     PrettyPrintResources.TOKEN_EXTENDED_KEY_USAGE) + "\n");
             ExtendedKeyUsageExtension usage = (ExtendedKeyUsageExtension) mExt;
-            Enumeration e = usage.getOIDs();
+            Enumeration<ObjectIdentifier> e = usage.getOIDs();
 
             if (e != null) {
                 while (e.hasMoreElements()) {
@@ -969,12 +969,12 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(PrettyPrintResources.TOKEN_CRITICAL));
             CertificateScopeOfUseExtension ext = (CertificateScopeOfUseExtension) mExt;
 
-            if (((Extension) mExt).isCritical()) {
+            if (mExt.isCritical()) {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_YES) + "\n");
             } else {
                 sb.append(mResource.getString(PrettyPrintResources.TOKEN_NO) + "\n");
             }
-            Vector entries = ext.getCertificateScopeEntries();
+            Vector<CertificateScopeEntry> entries = ext.getCertificateScopeEntries();
 
             if (entries != null) {
                 sb.append(pp.indent(mIndentSize + 4) +
@@ -1466,7 +1466,7 @@ public class ExtPrettyPrint {
             }
 
             PolicyMappingsExtension ext = (PolicyMappingsExtension) mExt;
-            Enumeration maps = ext.getMappings();
+            Enumeration<CertificatePolicyMap> maps = ext.getMappings();
 
             sb.append(pp.indent(mIndentSize + 4) +
                 mResource.getString(PrettyPrintResources.TOKEN_MAPPINGS));
@@ -1522,7 +1522,7 @@ public class ExtPrettyPrint {
 
             sb.append(pp.indent(mIndentSize + 4) +
                 mResource.getString(PrettyPrintResources.TOKEN_ATTRIBUTES));
-            Enumeration attrs = ext.getAttributesList();
+            Enumeration<Attribute> attrs = ext.getAttributesList();
 
             if (attrs == null || !attrs.hasMoreElements()) {
                 sb.append(
@@ -1542,7 +1542,7 @@ public class ExtPrettyPrint {
                     sb.append(pp.indent(mIndentSize + 12) +
                         mResource.getString(
                             PrettyPrintResources.TOKEN_VALUES));
-                    Enumeration values = attr.getValues();
+                    Enumeration<String> values = attr.getValues();
 
                     if (values == null || !values.hasMoreElements()) {
                         sb.append(mResource.getString(
@@ -1585,12 +1585,13 @@ public class ExtPrettyPrint {
             sb.append(pp.indent(mIndentSize + 4) + mResource.getString(
                     PrettyPrintResources.TOKEN_CERT_POLICIES) + "\n");
             CertificatePoliciesExtension cp = (CertificatePoliciesExtension) mExt;
-            Vector cpv = (Vector) cp.get("infos");
-            Enumeration e = cpv.elements();
+            @SuppressWarnings("unchecked")
+			Vector<CertificatePolicyInfo> cpv = (Vector<CertificatePolicyInfo>) cp.get("infos");
+            Enumeration<CertificatePolicyInfo> e = cpv.elements();
 
             if (e != null) {
                 while (e.hasMoreElements()) {
-                    CertificatePolicyInfo cpi = (CertificatePolicyInfo) e.nextElement();
+                    CertificatePolicyInfo cpi = e.nextElement();
 
                     sb.append(pp.indent(mIndentSize + 8) + "Policy Identifier: " + cpi.getPolicyIdentifier().getIdentifier().toString() + "\n");
                     PolicyQualifiers cpq = cpi.getPolicyQualifiers();
diff --git a/pki/base/util/src/netscape/security/x509/ACertAttrSet.java b/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
index b5ce1773ce0cac8264770978473accd2d796e386..098a5f2d8dc318369f883b592958115923b16fcd 100755
--- a/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
+++ b/pki/base/util/src/netscape/security/x509/ACertAttrSet.java
@@ -125,7 +125,7 @@ public class ACertAttrSet implements CertAttrSet {
      * 
      * @return an enumeration of the attribute names.
      */
-    public Enumeration getElements() {
+    public Enumeration<String> getAttributeNames() {
 		return null;
 	}
  
diff --git a/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java b/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
index c0eff9b345f9ac27afed4141b06e85aaec261fb7..6e330f8a4a0eae33e0981f243e4f2d645bc5d8bd 100644
--- a/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
+++ b/pki/base/util/src/netscape/security/x509/AuthorityKeyIdentifierExtension.java
@@ -66,7 +66,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "AuthorityKeyIdentifier";
     public static final String KEY_ID = "key_id";
     public static final String AUTH_NAME = "auth_name";
     public static final String SERIAL_NUMBER = "serial_number";
@@ -321,7 +320,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(KEY_ID);
         elements.addElement(AUTH_NAME);
@@ -330,10 +329,4 @@ implements CertAttrSet {
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 }
diff --git a/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java b/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
index 7314c2ac038dbd6e94ff91e2b504476681806678..a92625a8736f55a5435ffa4f5e8802b4012055e6 100644
--- a/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/BasicConstraintsExtension.java
@@ -62,7 +62,6 @@ implements CertAttrSet {
     /**
      * Attribute names.
      */
-    public static final String NAME = "BasicConstraints";
     public static final String IS_CA = "is_ca";
     public static final String PATH_LEN = "path_len";
 
@@ -277,7 +276,7 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(IS_CA);
         elements.addElement(PATH_LEN);
@@ -285,10 +284,4 @@ implements CertAttrSet {
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-        return (NAME);
-    }
 }
diff --git a/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java b/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
index aa8c20b822a511ba97d3159e49b6283d219de9ff..812d2e76f1271afe3e193d3bfd542a2401d422dd 100644
--- a/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLDistributionPointsExtension.java
@@ -177,17 +177,16 @@ public class CRLDistributionPointsExtension extends Extension
     // because it is so complicated. Therefore, we only provide a
     // minimal implementation.
     /////////////////////////////////////////////////////////////
-    public static final String NAME = "CRLDistributionPoints";
 
      static {
          try {
             OIDMap.addAttribute(CRLDistributionPointsExtension.class.getName(),
-                                OID, NAME);
+                                OID, CRLDistributionPointsExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
     public String toString() {
-        return NAME;
+        return this.getClass().getSimpleName();
     }
 
     /**
@@ -231,15 +230,14 @@ public class CRLDistributionPointsExtension extends Extension
         throw new IOException("Attribute name not recognized by " + 
             "CertAttrSet:CRLDistributionPointsExtension");
     }
-
-    public Enumeration getElements() {
-        return (new Vector()).elements();
+    /*
+     *	TODO use an empty collection to generate these 
+     */
+    public Enumeration<String> getAttributeNames() {
+        return (new Vector<String>()).elements();
     }
 
 
-    public String getName() {
-        return NAME;
-    }
 
     /**
      * Test driver.
@@ -319,11 +317,11 @@ public class CRLDistributionPointsExtension extends Extension
 		    list.addElement(this);
         }
 
-        private static Hashtable map = new Hashtable();
-	    private static Vector list = new Vector();
+        private static Hashtable<String, Reason> map = new Hashtable<String, Reason>();
+	    private static Vector<Reason> list = new Vector<Reason>();
 
         public static Reason fromString(String name) {
-            return (Reason) map.get(name);
+            return  map.get(name);
         }
 
         public String getName() {
@@ -359,9 +357,9 @@ public class CRLDistributionPointsExtension extends Extension
 	    public static Reason[] bitArrayToReasonArray(byte[] bitFlags) {
 		    byte first = bitFlags[0];
 		    int size = list.size();
-		    Vector result = new Vector();
+		    Vector<Reason> result = new Vector<Reason>();
 		    for(int i = 0; i < size; i++) {
-			    Reason r = (Reason) list.elementAt(i);
+			    Reason r =  list.elementAt(i);
 			    byte b = r.getBitMask();
 			    if( (first & b) != 0 ) {
 				    result.addElement(r);
@@ -370,7 +368,7 @@ public class CRLDistributionPointsExtension extends Extension
 		    size = result.size();
 		    Reason[] retval = new Reason[size];
 		    for(int i=0; i < size; i++) {
-			    retval[i] = (Reason) result.elementAt(i);
+			    retval[i] =  result.elementAt(i);
 		    }
 		    return retval;
 	    }
diff --git a/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java b/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
index 67baf106b6c8db99689dcb7a9104ddbeeae405ae..8376662fd856ec672698b6c09f07867569024a08 100755
--- a/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLNumberExtension.java
@@ -53,7 +53,6 @@ implements CertAttrSet {
     /**
      * Attribute name.
      */
-    public static final String NAME = "CRLNumber";
     public static final String NUMBER = "value";
 
     private BigInt crlNumber = null;
@@ -210,16 +209,10 @@ implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(NUMBER);
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
     }
-}
diff --git a/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java b/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
index 8f10ac6abc35854722b13fd2ebd9995902140d63..363e54bfb0c9b9db19cd0cedf0f20d590b2e1ae9 100644
--- a/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CRLReasonExtension.java
@@ -61,7 +61,6 @@ public final class CRLReasonExtension  extends Extension implements CertAttrSet
     /**
      * Attribute names.
      */
-	public static final String NAME = "CRLReason";
 	public static final String REASON = "value";
 
     private RevocationReason mReason = null;
@@ -206,19 +205,13 @@ public final class CRLReasonExtension  extends Extension implements CertAttrSet
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements () {
+    public Enumeration<String> getAttributeNames () {
         Vector<String> elements = new Vector<String>();
         elements.addElement(REASON);
 
 	return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName () {
-        return (NAME);
-    }
 
 	public boolean equals(Object other) {
 		if (this == other)
diff --git a/pki/base/util/src/netscape/security/x509/CertAttrSet.java b/pki/base/util/src/netscape/security/x509/CertAttrSet.java
index 53401132fa8a3234fe733530f579927d212db766..4b9352c6497d36abace8abed72d3e850580aeb1d 100755
--- a/pki/base/util/src/netscape/security/x509/CertAttrSet.java
+++ b/pki/base/util/src/netscape/security/x509/CertAttrSet.java
@@ -111,8 +111,9 @@ public interface CertAttrSet {
      * 
      * @return an enumeration of the attribute names.
      */
-    Enumeration getElements();
+    Enumeration<String> getAttributeNames();
  
+        
     /**
      * Returns the name (identifier) of this CertAttrSet.
      * 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java b/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
index 48fcb454dab8afa2a8d1bf74161053b327c91e6b..676df900701c27819c8b8ecc6a9cabc3ddb20e7f 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateAlgorithmId.java
@@ -173,7 +173,7 @@ public class CertificateAlgorithmId implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ALGORITHM);
         return (elements.elements());
diff --git a/pki/base/util/src/netscape/security/x509/CertificateExtensions.java b/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
index 1f616d67293805f80b5785ad42936935d7343342..6075715aef02a74271aa71456e93f0c1f419859d 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateExtensions.java
@@ -43,7 +43,7 @@ import netscape.security.util.DerValue;
  * @version 1.11
  * @see CertAttrSet
  */
-public class CertificateExtensions extends Vector
+public class CertificateExtensions extends Vector<Extension>
 implements CertAttrSet, Serializable {
     /**
      *
@@ -59,12 +59,13 @@ implements CertAttrSet, Serializable {
      */
     public static final String NAME = "extensions";
 
-    private Hashtable<String, Object> map;
+    private Hashtable<String, Extension> map;
 
     // Parse the encoded extension
     public void parseExtension(Extension ext) throws IOException {
         try {
-            Class extClass = OIDMap.getClass(ext.getExtensionId());
+            @SuppressWarnings("unchecked")
+			Class<Extension> extClass = (Class<Extension>) OIDMap.getClass(ext.getExtensionId());
             if (extClass == null) {   // Unsupported extension
                 if (ext.isCritical()) {
                     throw new IOException("Unsupported CRITICAL extension: "
@@ -75,8 +76,8 @@ implements CertAttrSet, Serializable {
                     return;
                 }
             }
-            Class[] params = {Boolean.class, Object.class};
-            Constructor cons = extClass.getConstructor(params);
+            Class<?>[] params = {Boolean.class, Object.class};
+            Constructor<Extension> cons = extClass.getConstructor(params);
 
             byte[] extData = ext.getExtensionValue();
             int extLen = extData.length;
@@ -87,7 +88,7 @@ implements CertAttrSet, Serializable {
             }
             Object[] passed = new Object[]{new Boolean(ext.isCritical()),
                     value};
-            CertAttrSet certExt = (CertAttrSet) cons.newInstance(passed);
+            Extension certExt = cons.newInstance(passed);
             if (certExt != null && certExt.getName() != null) {
                 map.put(certExt.getName(), (Extension) certExt);
                 addElement((Extension) certExt);
@@ -105,7 +106,7 @@ implements CertAttrSet, Serializable {
      * Default constructor for the certificate attribute.
      */
     public CertificateExtensions() {
-        map = new Hashtable();
+        map = new Hashtable<String, Extension> ();
     }
 
     /**
@@ -117,7 +118,7 @@ implements CertAttrSet, Serializable {
     public CertificateExtensions(DerInputStream in)
         throws IOException {
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = in.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -136,7 +137,7 @@ implements CertAttrSet, Serializable {
         DerValue val = new DerValue(in);
         DerInputStream str = val.toDerInputStream();
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -160,7 +161,7 @@ implements CertAttrSet, Serializable {
 	  str = val.toDerInputStream();
         }
 
-        map = new Hashtable();
+        map = new Hashtable<String, Extension>();
         DerValue[] exts = str.getSequence(5);
 
         for (int i = 0; i < exts.length; i++) {
@@ -216,8 +217,8 @@ implements CertAttrSet, Serializable {
      * @exception IOException if the object could not be cached.
      */
     public void set(String name, Object obj) throws IOException {
-        map.put(name,obj);
-        addElement(obj);
+        map.put(name,(Extension) obj);
+        addElement((Extension) obj);
     }
 
     /**
@@ -247,7 +248,7 @@ implements CertAttrSet, Serializable {
         removeElement(obj);
     }
 
-    public Enumeration getNames()
+    public Enumeration<String> getNames()
     {
 	return map.keys();
     }
@@ -256,10 +257,15 @@ implements CertAttrSet, Serializable {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration getElements () {
+    public Enumeration<Extension> getAttributes() {
         return (map.elements());
     }
 
+    
+    public Enumeration<String> getAttributeNames () {
+        return (map.keys());
+    }
+    
     /**
      * Return the name of this attribute.
      */
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
index 73d9c1d1122ad6c32ace4bf239ed8a2ce6621c57..55f21d2a12c87d299cd2da3ec360aca785fc2959 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerExtension.java
@@ -51,7 +51,6 @@ public class CertificateIssuerExtension extends Extension
     /**
      * Attribute name.
      */
-    public static final String NAME = "CertificateIssuer";
     public static final String CERTIFICATE_ISSUER = "value";
 
     /**
@@ -65,7 +64,7 @@ public class CertificateIssuerExtension extends Extension
     static {
         try {
             OIDMap.addAttribute(CertificateIssuerExtension.class.getName(),
-                                OID, NAME);
+                                OID, CertificateIssuerExtension.class.getSimpleName());
         } catch (CertificateException e) {}
     }
 
@@ -231,18 +230,12 @@ public class CertificateIssuerExtension extends Extension
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(CERTIFICATE_ISSUER);
 
         return (elements.elements());
     }
 
-    /**
-     * Return the name of this attribute.
-     */
-    public String getName() {
-        return (NAME);
-    }
 }
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
index 22d05d075c945365f357ffe953c1b8594d725d8f..47c44ed4f794b0c985f418e13dcf790866d382fe 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerName.java
@@ -155,7 +155,7 @@ public class CertificateIssuerName implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(DN_NAME);
 
diff --git a/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java b/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
index 687aedb456f26666017df55bd2c9124f9ec3bcd2..52baa621b588fb49bf502d674f3bbb5de8c8f650 100644
--- a/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
+++ b/pki/base/util/src/netscape/security/x509/CertificateIssuerUniqueIdentity.java
@@ -168,7 +168,7 @@ public class CertificateIssuerUniqueIdentity implements CertAttrSet {
      * Return an enumeration of names of attributes existing within this
      * attribute.
      */
-    public Enumeration<String> getElements() {
+    public Enumeration<String> getAttributeNames() {
         Vector<String> elements = new Vector<String>();
         elements.addElement(ID);
 
